/*
 * Copyright 2014 (c) Anna Schumaker.
 */
#include <core/deck.h>
#include <gui/tabs.h>
#include <gui/queue/label.h>


class HistoryTab : public Tab {
private:
	HistoryLabel *history_label;

public:
	HistoryTab() : Tab(deck :: get_queue())
	{
		tab_builder->add_from_file(gui :: share_file("QueueLabel.ui"));
		tab_builder->get_widget_derived("HistoryLabel", history_label);
		tab_toolbar->init(tab_pq, history_label, tab_window, 0);

		history_label->init(tab_pq);
		tab_label = history_label;

		tab_vbox.pack_start(*tab_window, true, true);

		gui :: get_widget<Gtk::Notebook>("o_notebook")->insert_page(tab_vbox, *history_label, 0);
	}

	~HistoryTab()
	{
		tab_unmap();
	}
};


static HistoryTab *history_tab;

void init_history_tab()
{
	history_tab = new HistoryTab;
}
