/**
 * Copyright (c) 2013 Anna Schumaker.
 */
#ifndef OCARINA_CORE_PRINT_H
#define OCARINA_CORE_PRINT_H

#include <cstdio>
#include <cstdarg>

/**
 * Print a message to the console
 *
 * @param  fmt  Printf-style text format.
 * @param  ...  Var-args matching the specified format.
 */
inline void print(const char *fmt, ...)
{
	va_list ap;

	va_start(ap, fmt);
	vprintf(fmt, ap);
	va_end(ap);
}

#endif /* OCARINA_CORE_PRINT_H */
