/*
 * Copyright 2014 (c) Anna Schumaker
 */
#ifndef OCARINA_CORE_RANDOM_H
#define OCARINA_CORE_RANDOM_H

#ifdef CONFIG_TESTING

void _seed_random(unsigned int);
unsigned int _pick_random();

#else /* CONFIG_TESTING */

#include <stdlib.h>
static inline void _seed_random(unsigned int n) { srand(time(NULL) + n); }
static inline unsigned int _pick_random() { return rand(); }

#endif /* CONFIG_TESTING */



/* Seed the random number generator. */
static inline void random_seed(unsigned int n)
{
	_seed_random(n);
}

/*  Returns a random number X, where min <= value <= max. */
static inline unsigned int random_range(unsigned int min, unsigned int max)
{
	if (min >= max)
		return min;
	return min + (_pick_random() % (max - min));
}

#endif /* OCARINA_CORE_RANDOM_H */
