/*
 * Copyright 2014 (c) Anna Schumaker.
 */
#ifndef OCARINA_H
#define OCARINA_H

#include <core/queue.h>
#include <gtkmm.h>


/* main.cpp */
namespace gui
{
	extern Glib::RefPtr<Gtk::Builder> __O_BUILDER;

	const std::string share_file(const std::string &);

	template <class T>
	static inline T *get_widget(const std::string &name)
	{
		T *widget;
		__O_BUILDER->get_widget(name, widget);
		return widget;
	}

	template <class T>
	static inline Glib::RefPtr<T> get_object(const std::string &name)
	{
		return Glib::RefPtr<T>::cast_static(__O_BUILDER->get_object(name));
	}
}


void on_pq_created(Queue *, unsigned int);
void post_init_queue_tabs();


/* gst.cpp */
namespace gst
{
	void next();
	void toggle();
	void init(int *, char ***);
	void quit();
}


/* manager.cpp */
namespace manager
{
	void init();
}


/* playlist.cpp */
namespace plist
{
	void track_loaded(struct track *track);
	void init();
}


/* window.cpp */
Gtk::Window *window_init();

#endif /* OCARINA_H */
